/* $Id: d_mos1.model,v 17.24 2000/06/02 17:15:02 al Exp $ -*- C++ -*-
 * mos model equations: spice level 1 equivalent
 */
/* This file is automatically generated. DO NOT EDIT */
#include "ap.h"
#include "d_mos1.h"
/*--------------------------------------------------------------------------*/
const double NA(NOT_INPUT);
/*--------------------------------------------------------------------------*/
int MODEL_MOS1::_count = 0;
/*--------------------------------------------------------------------------*/
SDP_MOS1::SDP_MOS1(const COMPONENT_COMMON* cc)
  :SDP_MOS123(cc)
{
}
/*--------------------------------------------------------------------------*/
TDP_MOS1::TDP_MOS1(const DEV_MOS* d)
  :TDP_MOS123(d)
{
  assert(d);
  const MOS_COMMON* c = prechecked_cast<const MOS_COMMON*>(d->common());
  assert(c);
  const SDP_MOS1* b = prechecked_cast<const SDP_MOS1*>(c->sdp);
  assert(b);
  const MODEL_MOS1* m = prechecked_cast<const MODEL_MOS1*>(c->model());
  assert(m);

      double temp = SIM::temp;
      double tempratio  = temp / m->_tnom;
      double tempratio4 = tempratio * sqrt(tempratio);
      double kt = temp * K;
      double vt = kt / Q;
      double egap = 1.16 - (7.02e-4*temp*temp) / (temp+1108.);
      double arg = (m->egap*tempratio - egap) / (2*kt);

  phi = m->phi*tempratio + (-2*vt*(1.5*log(tempratio)+Q*(arg)));
  beta = m->kp * tempratio4 * b->we / b->le;
  sqrt_phi = sqrt(phi);
}
/*--------------------------------------------------------------------------*/
MODEL_MOS1::MODEL_MOS1()
  :MODEL_MOS123()
{
  ++_count;
}
/*--------------------------------------------------------------------------*/
bool MODEL_MOS1::parse_front(CS& cmd)
{
  return MODEL_MOS123::parse_front(cmd);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS1::parse_params(CS& cmd)
{
  MODEL_MOS123::parse_params(cmd);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS1::post_parse()
{
  MODEL_MOS123::post_parse();

  if (cox == NA) {
    cox = 0.;
  }
  cmodel = ((!cmodel)?2:cmodel);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS1::print_front(OMSTREAM& o)const
{
  MODEL_MOS123::print_front(o);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS1::print_params(OMSTREAM& o)const
{
  o << "level=1";
  MODEL_MOS123::print_params(o);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS1::print_calculated(OMSTREAM& o)const
{
  MODEL_MOS123::print_calculated(o);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS1::tr_eval(COMPONENT* brh)const
{
  DEV_MOS* d = prechecked_cast<DEV_MOS*>(brh);
  assert(d);
  const MOS_COMMON* c = prechecked_cast<const MOS_COMMON*>(d->common());
  assert(c);
  const SDP_MOS1* b = prechecked_cast<const SDP_MOS1*>(c->sdp);
  assert(b);
  const MODEL_MOS1* m = this;
  TDP_MOS1 t(d);

    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 
    trace1(d->long_label().c_str(), d->evaliter());
    trace3("", d->vds, d->vgs, d->vbs);
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 
    double sarg, dsarg_dvbs;
    {
      {if (d->vbs <= 0.) {
	sarg = sqrt(t.phi - d->vbs);
	dsarg_dvbs = -.5 / sarg;
	d->sbfwd = false;
	trace2("sb-ok", sarg, dsarg_dvbs);
      }else{
	untested();
	sarg = t.sqrt_phi / (1. + .5 * d->vbs / t.phi);
	dsarg_dvbs = -.5 * sarg * sarg / t.phi*t.sqrt_phi; /* is wrong!! */
	d->sbfwd = true;
	trace2("***sb-reversed***", sarg, dsarg_dvbs);
      }}
    }
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 
    {
      {if (d->vbs - d->vds <= 0.) {
	d->dbfwd = false;
      }else{
	untested();
	d->dbfwd = true;
      }}
    }
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 
    d->von = m->vto + m->gamma * (sarg - t.sqrt_phi);
    d->vgst = d->vdsat = d->vgs - d->von;
    if (d->vdsat < 0.) {
      d->vdsat = 0.;
    }
    d->cutoff = (d->vgst < 0.);
    d->saturated = (d->vds > d->vdsat);
    trace3("", d->von, d->vgst, d->vdsat);
    double Lambda = (m->lambda != NA) ? m->lambda : 0.;
    /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 
    {if (d->cutoff) {
      d->gds = d->gm = d->ids = d->gmb = 0.;
      trace4("cut", d->ids, d->gm, d->gds, d->gmb);
    }else if (d->saturated) {
      d->gm  = t.beta * d->vgst * (1. + Lambda * d->vds);
      d->ids = d->gm * (.5 * d->vgst);
      d->gds = .5 * t.beta * Lambda * d->vgst * d->vgst;
      d->gmb = - d->gm * m->gamma * dsarg_dvbs;
      trace4("sat", d->ids, d->gm, d->gds, d->gmb);
    }else{ /* linear */
      d->gm  = t.beta * d->vds * (1. + Lambda * d->vds);
      d->ids = d->gm * (d->vgst - .5*d->vds);
      d->gds = t.beta * ((d->vgst - d->vds) 
			 + Lambda * d->vds * (2.*d->vgst - 1.5*d->vds));
      d->gmb = -d->gm * m->gamma * dsarg_dvbs;
      trace4("lin", d->ids, d->gm, d->gds, d->gmb);
    }}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
