/* $Id: d_mos123.model,v 17.24 2000/06/02 17:15:02 al Exp $ -*- C++ -*-
 * MOS model - base for levels 1,2,3,6
 */
/* This file is automatically generated. DO NOT EDIT */

  enum gate_t {gOPP = -1, gMETAL = 0, gSAME = 1};
  const double NI = 1.45e16;	/* intrinsic carrier concentration */
#include "ap.h"
#include "d_mos123.h"
/*--------------------------------------------------------------------------*/
const double NA(NOT_INPUT);
/*--------------------------------------------------------------------------*/
int MODEL_MOS123::_count = 0;
/*--------------------------------------------------------------------------*/
SDP_MOS123::SDP_MOS123(const COMPONENT_COMMON* cc)
  :SDP_MOS_BASE(cc)
{
  assert(cc);
  const MOS_COMMON* c = prechecked_cast<const MOS_COMMON*>(cc);
  assert(c);
  const MODEL_MOS123* m = prechecked_cast<const MODEL_MOS123*>(c->model());
  assert(m);
  le = le - 2. * m->ld;
  cgate = m->cox * we * le;
  phi = m->phi;
}
/*--------------------------------------------------------------------------*/
TDP_MOS123::TDP_MOS123(const DEV_MOS* d)
  :TDP_MOS_BASE(d)
{
}
/*--------------------------------------------------------------------------*/
MODEL_MOS123::MODEL_MOS123()
  :MODEL_MOS_BASE(),
   vto(NA),
   kp(NA),
   gamma(NA),
   phi(NA),
   lambda(NA),
   tox(NA),
   nsub(NA),
   nss(0.0),
   xj(NA),
   ld(0.0),
   uo((600.*CM2M2)),
   delta(0.0),
   tpg(gSAME),
   cox(NA),
   sqrt_phi(NA),
   phi_sqrt_phi(NA),
   vfb(NA),
   vbi(NA),
   calc_vto(false),
   calc_kp(false),
   calc_gamma(false),
   calc_phi(false)
{
  ++_count;
}
/*--------------------------------------------------------------------------*/
bool MODEL_MOS123::parse_front(CS& cmd)
{
  return MODEL_MOS_BASE::parse_front(cmd);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS123::parse_params(CS& cmd)
{
  get(cmd, "VTO", &vto, mSCALE, (static_cast<double>(polarity)));
  get(cmd, "KP", &kp);
  get(cmd, "GAmma", &gamma);
  get(cmd, "PHI", &phi, mPOSITIVE);
  get(cmd, "LAmbda", &lambda);
  get(cmd, "TOX", &tox, mPOSITIVE);
  get(cmd, "NSUb", &nsub, mSCALE, ICM2M3);
  get(cmd, "NSS", &nss, mSCALE, ICM2M2);
  get(cmd, "XJ", &xj, mPOSITIVE);
  get(cmd, "LD", &ld);
  get(cmd, "UO", &uo, mSCALE, CM2M2);
  get(cmd, "DELta", &delta);
  get(cmd, "TPG", &tpg);
  MODEL_MOS_BASE::parse_params(cmd);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS123::post_parse()
{
  MODEL_MOS_BASE::post_parse();

      if (pb == NA) {	// override base, needed early
	pb = 0.8;
      }

      {if (tpg < 0) {		// coerce tpg to a proper value
	tpg = gOPP;		
      }else if (tpg > 0) {
	tpg = gSAME;
      }else{
	assert(tpg == gMETAL);
      }}
      
      if (tox != NA && tox <= 0) {
	untested();
	tox = NA;
	error(bWARNING, long_label()+": tox == 0, treating as if not input\n");
      }

      if (tox != NA) {
	cox = E_OX / tox;
	if (kp == NA) {
	  kp = uo * cox;
	  calc_kp = true;
	}
	
	if (nsub != NA) {
	  nsub = abs(nsub);
	  if (nsub < NI) {
	    untested();
	    error(bWARNING, long_label() + ": nsub < ni\n");
	    nsub = NI;
	  }
	  if (cjo == NA) {
	    cjo = sqrt(E_SI * Q * nsub / (2. * pb));
	    calc_cj = true;
	  }
	  if (phi == NA) {
	    phi = (2.*KoQ) * _tnom * log(nsub/NI);
	    if (phi < .1) {
	      untested();
	      error(bWARNING,
		    long_label() + ": calculated phi too small, using .1\n");
	      phi = .1;
	    }
	    calc_phi = true;
	  }
	  if (gamma == NA) {
	    gamma = sqrt(2. * E_SI * Q * nsub) / cox;
	    calc_gamma = true;
	  }
	  if (vto == NA) {
	    double phi_ms = (tpg == gMETAL)
	      ? -.05 - (egap + polarity * phi) / 2.
	      : -polarity * (tpg * egap + phi) / 2.;
	    
	    vfb = phi_ms - Q * nss / cox;
	    vto = vfb + polarity * (phi + gamma * sqrt(phi));
	    calc_vto = true;
	  }
	}
      }

  if (pb == NA) {
    pb = 0.8;
  }
  if (pbsw == NA) {
    pbsw = pb;
  }
  if (cjo == NA) {
    cjo = 0.0;
  }
  if (vto == NA) {
    vto = 0.0;
  }
  if (kp == NA) {
    kp = 2e-5;
  }
  if (gamma == NA) {
    gamma = 0.0;
  }
  if (phi == NA) {
    phi = 0.6;
  }
  lambda = std::min(lambda, 0.2);
  sqrt_phi = sqrt(phi);
  phi_sqrt_phi = phi * sqrt_phi;
  if (vfb == NA) {
    vfb = vto - (phi + gamma * sqrt_phi);
  }
  vbi = vfb + phi;
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS123::print_front(OMSTREAM& o)const
{
  MODEL_MOS_BASE::print_front(o);
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS123::print_params(OMSTREAM& o)const
{
  MODEL_MOS_BASE::print_params(o);
  if (!calc_vto)
    o << "  vto=" << vto/((static_cast<double>(polarity)));
  if (!calc_kp)
    o << "  kp=" << kp;
  if (!calc_gamma)
    o << "  gamma=" << gamma;
  if (!calc_phi)
    o << "  phi=" << phi;
  if (lambda != NA)
    o << "  lambda=" << lambda;
  if (tox != NA)
    o << "  tox=" << tox;
  if (nsub != NA)
    o << "  nsub=" << nsub/(ICM2M3);
  if (nss != 0.0 || nsub != NA)
    o << "  nss=" << nss/(ICM2M2);
  if (xj != NA)
    o << "  xj=" << xj;
  o << "  ld=" << ld;
  o << "  uo=" << uo/(CM2M2);
  o << "  delta=" << delta;
  o << "  tpg=" << tpg;
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS123::print_calculated(OMSTREAM& o)const
{
  MODEL_MOS_BASE::print_calculated(o);
  if (calc_vto)
    o << "* vto=" << vto/((static_cast<double>(polarity)));
  if (calc_kp)
    o << "* kp=" << kp;
  if (calc_gamma)
    o << "* gamma=" << gamma;
  if (calc_phi)
    o << "* phi=" << phi;
  if (true)
    o << "* cox=" << cox;
  if (true)
    o << "* vfb=" << vfb;
  if (true)
    o << "* vbi=" << vbi;
}
/*--------------------------------------------------------------------------*/
void MODEL_MOS123::tr_eval(COMPONENT*)const
{
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
